# coding: utf-8

"""
    VMware Aria Automation Pipelines APIs

    Aria Automation Pipelines is a continuous integration and continuous delivery (CICD) tool that you use to build Pipelines that model the software release process in your DevOps lifecycle. By creating Pipelines, you build the code infrastructure that delivers your software rapidly and continuously.  This page describes the RESTful APIs for Aria Automation Pipelines. The APIs facilitate CRUD operations on the various resources and entities used throughout Aria Automation Pipelines (Pipelines, Endpoints, Variables, etc.) and allow operations on them (executing a Pipeline, validating an Endpoint connection, etc.).  The APIs that list collections of resources  also support OData like implementation. Below query params can be used across Aria Automation Pipelines entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/codestream/api/endpoints?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/codestream/api/endpoints?$expand=true&$top=10&$skip=2```  3. `page` and `$size` - page used in conjunction with `$size` helps in pagination of resources.      ```/codestream/api/endpoints?$expand=true&page=0&$size=5```  4. `$filter` - `$filter` returns a subset of resources that satisfy the given predicate expression.      ```     /codestream/api/endpoints?$filter=startswith(name, 'ABC')     /codestream/api/endpoints?$filter=toupper(name) eq 'ABCD-JENKINS'     /codestream/api/endpoints?$filter=substringof(%27bc%27,tolower(name))     /codestream/api/endpoints?$filter=name eq 'ABCD' and project eq 'demo'   # noqa: E501

    OpenAPI spec version: 2019-10-17
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class TaskExecution1(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'duration_in_micros': 'int',
        'end_time': 'int',
        'start_time': 'int',
        'endpoints': 'dict(str, str)',
        'failure_message': 'str',
        'id': 'str',
        'ignore_failure': 'bool',
        'input': 'object',
        'name': 'str',
        'notifications': 'list[Notification1]',
        'output': 'object',
        'pre_condition': 'str',
        'rollback_configuration': 'RollbackConfiguration1',
        'rollback_response': 'RollbackResponse1',
        'status': 'str',
        'status_message': 'str',
        'type': 'str'
    }

    attribute_map = {
        'duration_in_micros': '_durationInMicros',
        'end_time': '_endTime',
        'start_time': '_startTime',
        'endpoints': 'endpoints',
        'failure_message': 'failureMessage',
        'id': 'id',
        'ignore_failure': 'ignoreFailure',
        'input': 'input',
        'name': 'name',
        'notifications': 'notifications',
        'output': 'output',
        'pre_condition': 'preCondition',
        'rollback_configuration': 'rollbackConfiguration',
        'rollback_response': 'rollbackResponse',
        'status': 'status',
        'status_message': 'statusMessage',
        'type': 'type'
    }

    def __init__(self, duration_in_micros=None, end_time=None, start_time=None, endpoints=None, failure_message=None, id=None, ignore_failure=None, input=None, name=None, notifications=None, output=None, pre_condition=None, rollback_configuration=None, rollback_response=None, status=None, status_message=None, type=None):  # noqa: E501
        """TaskExecution1 - a model defined in Swagger"""  # noqa: E501
        self._duration_in_micros = None
        self._end_time = None
        self._start_time = None
        self._endpoints = None
        self._failure_message = None
        self._id = None
        self._ignore_failure = None
        self._input = None
        self._name = None
        self._notifications = None
        self._output = None
        self._pre_condition = None
        self._rollback_configuration = None
        self._rollback_response = None
        self._status = None
        self._status_message = None
        self._type = None
        self.discriminator = None
        if duration_in_micros is not None:
            self.duration_in_micros = duration_in_micros
        if end_time is not None:
            self.end_time = end_time
        if start_time is not None:
            self.start_time = start_time
        if endpoints is not None:
            self.endpoints = endpoints
        if failure_message is not None:
            self.failure_message = failure_message
        if id is not None:
            self.id = id
        if ignore_failure is not None:
            self.ignore_failure = ignore_failure
        if input is not None:
            self.input = input
        self.name = name
        if notifications is not None:
            self.notifications = notifications
        if output is not None:
            self.output = output
        if pre_condition is not None:
            self.pre_condition = pre_condition
        if rollback_configuration is not None:
            self.rollback_configuration = rollback_configuration
        if rollback_response is not None:
            self.rollback_response = rollback_response
        if status is not None:
            self.status = status
        if status_message is not None:
            self.status_message = status_message
        if type is not None:
            self.type = type

    @property
    def duration_in_micros(self):
        """Gets the duration_in_micros of this TaskExecution1.  # noqa: E501

        Execution duration of the Task Execution (in micros).  # noqa: E501

        :return: The duration_in_micros of this TaskExecution1.  # noqa: E501
        :rtype: int
        """
        return self._duration_in_micros

    @duration_in_micros.setter
    def duration_in_micros(self, duration_in_micros):
        """Sets the duration_in_micros of this TaskExecution1.

        Execution duration of the Task Execution (in micros).  # noqa: E501

        :param duration_in_micros: The duration_in_micros of this TaskExecution1.  # noqa: E501
        :type: int
        """

        self._duration_in_micros = duration_in_micros

    @property
    def end_time(self):
        """Gets the end_time of this TaskExecution1.  # noqa: E501

        End time of the Task Execution (in micros)..  # noqa: E501

        :return: The end_time of this TaskExecution1.  # noqa: E501
        :rtype: int
        """
        return self._end_time

    @end_time.setter
    def end_time(self, end_time):
        """Sets the end_time of this TaskExecution1.

        End time of the Task Execution (in micros)..  # noqa: E501

        :param end_time: The end_time of this TaskExecution1.  # noqa: E501
        :type: int
        """

        self._end_time = end_time

    @property
    def start_time(self):
        """Gets the start_time of this TaskExecution1.  # noqa: E501

        Start time of the Task Execution (in micros)..  # noqa: E501

        :return: The start_time of this TaskExecution1.  # noqa: E501
        :rtype: int
        """
        return self._start_time

    @start_time.setter
    def start_time(self, start_time):
        """Sets the start_time of this TaskExecution1.

        Start time of the Task Execution (in micros)..  # noqa: E501

        :param start_time: The start_time of this TaskExecution1.  # noqa: E501
        :type: int
        """

        self._start_time = start_time

    @property
    def endpoints(self):
        """Gets the endpoints of this TaskExecution1.  # noqa: E501

        Endpoints that the Task refers to.  # noqa: E501

        :return: The endpoints of this TaskExecution1.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._endpoints

    @endpoints.setter
    def endpoints(self, endpoints):
        """Sets the endpoints of this TaskExecution1.

        Endpoints that the Task refers to.  # noqa: E501

        :param endpoints: The endpoints of this TaskExecution1.  # noqa: E501
        :type: dict(str, str)
        """

        self._endpoints = endpoints

    @property
    def failure_message(self):
        """Gets the failure_message of this TaskExecution1.  # noqa: E501

        Failure message associated with a 'FAILED' task.  # noqa: E501

        :return: The failure_message of this TaskExecution1.  # noqa: E501
        :rtype: str
        """
        return self._failure_message

    @failure_message.setter
    def failure_message(self, failure_message):
        """Sets the failure_message of this TaskExecution1.

        Failure message associated with a 'FAILED' task.  # noqa: E501

        :param failure_message: The failure_message of this TaskExecution1.  # noqa: E501
        :type: str
        """

        self._failure_message = failure_message

    @property
    def id(self):
        """Gets the id of this TaskExecution1.  # noqa: E501

        The id of this Task.  # noqa: E501

        :return: The id of this TaskExecution1.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this TaskExecution1.

        The id of this Task.  # noqa: E501

        :param id: The id of this TaskExecution1.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def ignore_failure(self):
        """Gets the ignore_failure of this TaskExecution1.  # noqa: E501

        Ignores the failure of the Task execution if set to true, and continues with the Pipeline execution.  # noqa: E501

        :return: The ignore_failure of this TaskExecution1.  # noqa: E501
        :rtype: bool
        """
        return self._ignore_failure

    @ignore_failure.setter
    def ignore_failure(self, ignore_failure):
        """Sets the ignore_failure of this TaskExecution1.

        Ignores the failure of the Task execution if set to true, and continues with the Pipeline execution.  # noqa: E501

        :param ignore_failure: The ignore_failure of this TaskExecution1.  # noqa: E501
        :type: bool
        """

        self._ignore_failure = ignore_failure

    @property
    def input(self):
        """Gets the input of this TaskExecution1.  # noqa: E501

        Map representing the Input properties for the Task.  # noqa: E501

        :return: The input of this TaskExecution1.  # noqa: E501
        :rtype: object
        """
        return self._input

    @input.setter
    def input(self, input):
        """Sets the input of this TaskExecution1.

        Map representing the Input properties for the Task.  # noqa: E501

        :param input: The input of this TaskExecution1.  # noqa: E501
        :type: object
        """

        self._input = input

    @property
    def name(self):
        """Gets the name of this TaskExecution1.  # noqa: E501

        A human-friendly name used as an identifier For the Task.  # noqa: E501

        :return: The name of this TaskExecution1.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this TaskExecution1.

        A human-friendly name used as an identifier For the Task.  # noqa: E501

        :param name: The name of this TaskExecution1.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def notifications(self):
        """Gets the notifications of this TaskExecution1.  # noqa: E501

        List of configured Notifications for Task Events.  # noqa: E501

        :return: The notifications of this TaskExecution1.  # noqa: E501
        :rtype: list[Notification1]
        """
        return self._notifications

    @notifications.setter
    def notifications(self, notifications):
        """Sets the notifications of this TaskExecution1.

        List of configured Notifications for Task Events.  # noqa: E501

        :param notifications: The notifications of this TaskExecution1.  # noqa: E501
        :type: list[Notification1]
        """

        self._notifications = notifications

    @property
    def output(self):
        """Gets the output of this TaskExecution1.  # noqa: E501

        Map representing the Output properties for the Task.  # noqa: E501

        :return: The output of this TaskExecution1.  # noqa: E501
        :rtype: object
        """
        return self._output

    @output.setter
    def output(self, output):
        """Sets the output of this TaskExecution1.

        Map representing the Output properties for the Task.  # noqa: E501

        :param output: The output of this TaskExecution1.  # noqa: E501
        :type: object
        """

        self._output = output

    @property
    def pre_condition(self):
        """Gets the pre_condition of this TaskExecution1.  # noqa: E501

        The Task is executed only if this field evaluates to true.  # noqa: E501

        :return: The pre_condition of this TaskExecution1.  # noqa: E501
        :rtype: str
        """
        return self._pre_condition

    @pre_condition.setter
    def pre_condition(self, pre_condition):
        """Sets the pre_condition of this TaskExecution1.

        The Task is executed only if this field evaluates to true.  # noqa: E501

        :param pre_condition: The pre_condition of this TaskExecution1.  # noqa: E501
        :type: str
        """

        self._pre_condition = pre_condition

    @property
    def rollback_configuration(self):
        """Gets the rollback_configuration of this TaskExecution1.  # noqa: E501


        :return: The rollback_configuration of this TaskExecution1.  # noqa: E501
        :rtype: RollbackConfiguration1
        """
        return self._rollback_configuration

    @rollback_configuration.setter
    def rollback_configuration(self, rollback_configuration):
        """Sets the rollback_configuration of this TaskExecution1.


        :param rollback_configuration: The rollback_configuration of this TaskExecution1.  # noqa: E501
        :type: RollbackConfiguration1
        """

        self._rollback_configuration = rollback_configuration

    @property
    def rollback_response(self):
        """Gets the rollback_response of this TaskExecution1.  # noqa: E501


        :return: The rollback_response of this TaskExecution1.  # noqa: E501
        :rtype: RollbackResponse1
        """
        return self._rollback_response

    @rollback_response.setter
    def rollback_response(self, rollback_response):
        """Sets the rollback_response of this TaskExecution1.


        :param rollback_response: The rollback_response of this TaskExecution1.  # noqa: E501
        :type: RollbackResponse1
        """

        self._rollback_response = rollback_response

    @property
    def status(self):
        """Gets the status of this TaskExecution1.  # noqa: E501

        Execution status of the Task Execution.  # noqa: E501

        :return: The status of this TaskExecution1.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this TaskExecution1.

        Execution status of the Task Execution.  # noqa: E501

        :param status: The status of this TaskExecution1.  # noqa: E501
        :type: str
        """
        allowed_values = ["NOT_STARTED", "STARTED", "RUNNING", "CANCELING", "WAITING", "RESUMING", "PAUSING", "PAUSED", "CANCELED", "COMPLETED", "FAILED", "SKIPPED", "QUEUED", "FAILED_CONTINUE", "ROLLING_BACK", "ROLLBACK_FAILED", "PREPARING_WORKSPACE", "ROLLBACK_COMPLETED"]  # noqa: E501
        if status not in allowed_values:
            raise ValueError(
                "Invalid value for `status` ({0}), must be one of {1}"  # noqa: E501
                .format(status, allowed_values)
            )

        self._status = status

    @property
    def status_message(self):
        """Gets the status_message of this TaskExecution1.  # noqa: E501

        Execution status message of the Task Execution.  # noqa: E501

        :return: The status_message of this TaskExecution1.  # noqa: E501
        :rtype: str
        """
        return self._status_message

    @status_message.setter
    def status_message(self, status_message):
        """Sets the status_message of this TaskExecution1.

        Execution status message of the Task Execution.  # noqa: E501

        :param status_message: The status_message of this TaskExecution1.  # noqa: E501
        :type: str
        """

        self._status_message = status_message

    @property
    def type(self):
        """Gets the type of this TaskExecution1.  # noqa: E501

        Type of the Task.  # noqa: E501

        :return: The type of this TaskExecution1.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this TaskExecution1.

        Type of the Task.  # noqa: E501

        :param type: The type of this TaskExecution1.  # noqa: E501
        :type: str
        """

        self._type = type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(TaskExecution1, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, TaskExecution1):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
